
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>浅谈.NET下的多线程和并行计算（四）线程同步基础 下 / iVAN</title>

    <meta name="description" content="浅谈.NET下的多线程和并行计算（四）线程同步基础 下 回顾一下上次,我们讨论了lock/AutoResetEvent/ManualResetEvent以及Semaphore.这些用于线程同 步的结构叫做同步基元.同步基元从类型上可以分为锁定/通知/联锁三种.lock显然锁定方式,而且是独 占锁定,也就是在锁释放之前不能由其它线程获得. Semaphore也是一种锁定,只不过不是独占锁,可以 指定多少个线程访问代码块.AutoResetEvent和ManualResetEvent当然就是通知方式了,前者在通行之后 自动重置,后者需要手动重置.我们还看">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">浅谈.NET下的多线程和并行计算（四）线程同步基础 下</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>回顾一下上次，我们讨论了lock/AutoResetEvent/ManualResetEvent以及Semaphore。这些用于线程同 步的结构叫做同步基元。同步基元从类型上可以分为锁定/通知/联锁三种。lock显然锁定方式，而且是独 占锁定，也就是在锁释放之前不能由其它线程获得。 Semaphore也是一种锁定，只不过不是独占锁，可以 指定多少个线程访问代码块。AutoResetEvent和ManualResetEvent当然就是通知方式了，前者在通行之后 自动重置，后者需要手动重置。我们还看到了即使使用同步机制不一定能确保线程按照我们规划的去执行 ，因为从根本上来说，操作系统的线程调度我们是没有办法预测的，除非使用阻塞或锁等待等方式，否则 我们很难去预测两个无关的线程究竟哪个先得到执行（即使设置了优先级），而且在使用这些同步机制的 时候我们也要考虑到性能问题，如果多线程程序做的不好的话很可能会比单线程执行效率还低，比如我们 开启了多个线程相互阻塞等待并没有任何的并行运算，比如在一个多线程环境汇总我们锁的范围很大，导 致多线程环境变为了一个单线程环境，有关性能问题以后再讨论，这次我们来看看其它的一些同步基元。</p>
<p>本文的例子基于上文定义的一些基本静态对象：</p>
<p><code>static　int　result　=　0;<br />
static　object　locker　=　new　object();<br />
static　EventWaitHandle　are　=　new　AutoResetEvent(false);<br />
static　EventWaitHandle　mre　=　new　ManualResetEvent(false);</code></p>
<p>使用lock保护共享资源不被多个线程同时修改是常见的做法，其实lock本质上基于Monitor，而使用 Monitor本身可以带来更丰富的特性，比如可以设置超过某个等待时间段就不继续等待：</p>
<p><code>for　(int　i　=　0;　i　&lt;　10;　i++)<br />
{<br />
　　 new　Thread(()　=&gt;<br />
　　 {<br />
　　　　 if　(Monitor.TryEnter(locker,　2000))<br />
　　　　 {<br />
　　　　　　 Thread.Sleep(1000);<br />
　　　　　　 Console.WriteLine(DateTime.Now.ToString("mm:ss"));<br />
　　　　　　 Monitor.Exit(locker);<br />
　　　　 }<br />
　　 }).Start();<br />
}</code></p>
<p>在这段代码中我们开启10个线程尝试申请locker独占锁，通过输出结果可以看出，由于我们设置了2秒 超时，程序只输出了三次：</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL3l1bnFpLXRlY2g0Lm9zcy1jbi1oYW5nemhvdS5hbGl5dW5jcy5jb20vMFAxMUgzNDUtMC5wbmc=.jpg">计算</a>（四）线程同步基础 下-java 多线程并行执行"&gt;</p>
<p>在第一个线程获取锁之后，一秒后释放，第二个线程获取，一秒后又释放，第三个线程最后获取到， 之后的线程都超过了2秒等待时间，TryEnter返回false，线程结束。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-23 19:37:11</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%90%8c%e6%ad%a5/" title="同步">同步</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b/" title="线程">线程</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b/" title="多线程">多线程</a>, <a href="https://www.iamivan.net/tag/static/" title="static">static</a>, <a href="https://www.iamivan.net/tag/monitor/" title="monitor">monitor</a>, <a href="https://www.iamivan.net/tag/%e5%a4%9a%e7%ba%bf%e7%a8%8b-%e7%ba%bf%e7%a8%8b%e5%90%8c%e6%ad%a5/" title="多线程 线程同步">多线程 线程同步</a>, <a href="https://www.iamivan.net/tag/%e7%ba%bf%e7%a8%8b%e5%90%8c%e6%ad%a5/" title="线程同步">线程同步</a>, <a href="https://www.iamivan.net/tag/%e7%8b%ac%e5%8d%a0%e7%ba%bf%e7%a8%8b/" title="独占线程">独占线程</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>浅谈.NET下的多线程和并行计算（四）线程同步基础 下的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLa64kz.html" rel="bookmark">浅谈java中异步多线程超时导致的服务异常&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在项目中为了提高大并发量时的性能稳定性,经常会使用到线程池来做多线程异步操作,多线程有2种,一种是实现runnable接口,这种没有返回值,一种是实现Callable接口,这种有返回值. 当其中一个线程超时的时候,理论上应该不 影响其他线程的执行结果,但是在项目中出现的问题表明一个线程阻塞,其他线程返回的接口都为空.其实是个很简单的问题,但是由于第一次碰到,还是想了一些时间的.很简单,就是因为阻塞的那个线 程没有释放,并发量一大,线程池数量就满了,所以其他线程都处于等待状态. 附上一段自己写的调			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M91RORM.html" rel="bookmark">浅谈&period;NET下的多线程和并行计算（十四）并行计算前言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				之前的文章中我们介绍了如何在.NET下运用相关类库进行多线程编程的基础,我们知道.NET 4.0已经 正式推出了,带来的重要特性是并行库.本文就谈谈对并行计算的一些理解和看法.并行计算不是一个很 新的概念,其实它就是通过多线程把同一个任务分割成多个子任务并行的执行的过程..NET 4.0并行库不 但提供了这方面的支持,而且还封装了多线程开发的各种场景,使得我们不需要依赖Thread/同步基元等 &quot;底层&quot;的对象就可以进行多线程开发.没有.NET 4.0的并行计算库我们同样可以进行并行计算			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bK7x2Ab.html" rel="bookmark">浅谈&period;NET下的多线程和并行计算（一）前言</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作为一个ASP.NET开发人员,在之前的开发经历中接触多线程编程的机会并不是很多,但是随着.NET 4.0的发布临近,我越来越感受到未来的1-2年中并行计算将会有很大的应用.于是决定通过写日志的方式 来总结一下.NET 3.5下的多线程编程进而引入.NET 4.0提供的新的并行库以及新的并行编程模式和编程的 思维方式. 个人觉得在日常的编程中对于ASP.NET程序员来说使用多线程编程不是很多,其实我们无时无刻不在享 受多线程的优势.首先,WEB服务器环境就是一个多线程环境,每一个请求都是独立的线			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZOGr6b.html" rel="bookmark">浅谈&period;NET下的多线程和并行计算（九）Winform中多线程编程基础 下</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在之前的文章中我们介绍过两种Timer和BackgroundWorker组件,在上文中我们提到过,强烈建议在UI 线程上操作控件,否则很容易产生人品问题.可以想到,上次介绍的两个Timer基于ThreadPool,回调方 法运行于不同于UI线程的新线程上,在这个方法中操作控件需要进行 Invoke或BeginInvoke.其实,还有 第三种System.Windows.Forms.Timer,它可以让回调事件在UI线程上执行,我们来做一个实验比较一下 System.Windows.Forms.T			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJ7G0Vb.html" rel="bookmark">浅谈&period;NET下的多线程和并行计算（十三）CLR via C&num;第三版阅读笔记（2）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				线程同步的问题 1) 我们必须找到代码中所有可能被多个线程同时访问的资源,然后使用线程同步来保护资源,并且 我们没有办法来验证是不是正确进行了线程同步,包括是否有遗漏和是否对不需要同步的资源进行同步. 2) 线程同步是有损性能的,如果某个操作大量执行,并且这个操作原先的执行时间非常短,那么如 果我们对这段操作前后进行锁的申请和释放的话性能可能下降一个数量级. 3) 线程同步可能导致更频繁的线程创建和上下文的切换. 当然,只有在下面的情况下才需要线程同步,换句话说我们尽量不要使用下面的方案来导致线			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pk2x9yM.html" rel="bookmark">浅谈&period;NET下的多线程和并行计算（三）线程同步基础 上</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				其实,如果线程都是很独立的,不涉及到任何资源访问的,那么这些毫无干扰的线程不会产生什么问 题.但是在实际应用中我们的线程总是涉及到资源访问的,而且往往涉及到共享资源的访问,那么就产生 了线程同步的问题.一直觉得线程同步这个名词很奇怪,字面上看同步就是使得步调一致,线程同步是不 是就是让线程步调一致的访问资源呢?事实上反了,线程同步恰巧是让线程不同时去访问资源而是去按照 我们期望的顺序依次访问资源(是同步资源访问的行为而不是同步同时访问资源).一句话,多个线程( 不仅仅局限于相同进程)如果需要访问			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/9zew78M.html" rel="bookmark">浅谈八点新浪家居结合百度搜索营销招数（下）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				上面一篇文章飞飞:浅谈八点新浪家居结合百度搜索营销招数(上)飞飞分析了四点新浪家居与百度搜索营销招数的其中四点,今天再分析其另外4点. 1搜索营销之百度百科,专业Web2.0编辑. 百度百科可谓一个互联网大智囊,充分调动网民的力量,汇集上亿用户的智慧,进行分享交流,新浪乐居在百科合作编辑词条,不仅可以帮助受众全面系统地了解品牌网站,同时也使信息更具品牌信服力. 2.搜索营销之知道专家,专业互动提升专业形象. 为全面提高百度知道平台的问答质量,帮助广大网友快速解决有关房产家居方面的问题,百度为新浪			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mq8Bjkb.html" rel="bookmark">浅谈JavaScript中setInterval和setTimeout的使用问题&lowbar;基础知识</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				说到setInterval,就不得不提到setTimeout,二者都是用于定时执行某函数,区别在于setTimeout 只执行一次,而setInterval可以一直连续不断执行下去,典型用法如下: function do_sth() { console.log('Hello...'); } setTimeout(do_sth, 2500); // 2.5 秒后,执行 do_sth 函数(只执行一次) setInterval(do_sth, 3500); // 3.5 秒后,执行 do_sth 函			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5WXJDb.html" rel="bookmark">浅谈中小企业网络推广最有效的四种方式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				中介交易 SEO诊断 淘宝客 云主机 技术大厅 近几年,随着互联网的快速的发展,国家对发展电子商务战略越来越重视,据消息称我国未来10年将有1万亿资金投入到电子商务.电子政务项目建设 中,越来越多的传统中小企业也应用和开展网络营销,市场竞争越来越大,现代中小企业如何在对手林立的市场中另辟蹊径呢,下面跟大家浅谈一下中小企业如何进 行网络推广 一. 广泛发布信息 首先加入各大行业B2B网站,把企业的信息发布物流行业的每个角落,这样客户更加容易找到你.全世界最伟大的汽车营销大师乔·吉拉德,就是满世 界			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9zeKD8M.html" rel="bookmark" class="title">java 技术分析</a>
					<div>
						代码一致性问题java 的代码是采取伪编译的,属于特殊的脚本文件:既然是脚本,当然是&quot;跨平台的&quot;:知道 php 吧? 编程思想问题java 确实引入了一些新的概念,对于编程是一种促 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apXkmvM.html" rel="bookmark" class="title">网站外链建设的几点感受</a>
					<div>
						随着百度算法的不断优化,前两年风靡的伪原创工具开始渐渐无用武之地,而且依据百度的优化指导说明,其对博客外链及论坛签名档似乎开始并不再那么倚重,这直接导致了很多人自然而然的认为网站外链推广的已经无法继续 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/wzVJvBz.html" rel="bookmark" class="title">邻接矩阵prim&colon;php实现图的邻接矩阵及普里姆&lpar;prim算法&rpar;&comma;弗洛伊德&lpar;floyd&rpar;&comma;迪杰斯特拉&lpar;dijkstra&rpar;算法</a>
					<div>
						&lt;?phprequire 'mgraph.php';$a = array('a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i');$b = array('ab' ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/VzwaWkM.html" rel="bookmark" class="title">模仿PHP写的ASP分页</a>
					<div>
						&lt;%' 分页程序' total_records 总记录数' everypage_records 每页显示条数' current_page 当前页数' url 要传递的url,这里可以含有要传递的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lpdg92M.html" rel="bookmark" class="title">数据库安装程序</a>
					<div>
						程序|数据|数据库 引言 最近做了一个数据库安装程序,本打算用 InstallShield X 来做的,结果D版没买到,用 Visual Studio.net 自带的安装工具又不能满足要求,最后只好自 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKYqNp.html" rel="bookmark" class="title">云存储：切勿忽略隐性成本</a>
					<div>
						云存储的定价与人们对一些工具的定价无异.长期以来,几乎所有的厂商都在重复着同样的口号:&quot;用户只需对他们使用的东西支付费用.&quot;公共云存储的价格范围为每月每GB 12%到25%. 51 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEljj3z.html" rel="bookmark" class="title">如何解决Outlook Express 无法收信及传送</a>
					<div>
						Outlook Express是Microsoft(微软)自带的一种电子邮件,简称为OE,是微软公司出品的一款电子邮件客户端,也是一个基于NNTP协议的Usenet客户端.但是使用时常常会莫名变的无法 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW19njz.html" rel="bookmark" class="title">Wps文字表格也能画流程图</a>
					<div>
						流程图可以在页面直接画,总之通过绘图工具画好,大量图组合,难度有点大,弄不好,辛苦劳动有时白流.用表格画流程图,不用组合,图可以随着表格移动,可以调整任何位置. 1.简单的图形 2.复杂的图形 三联推 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrLBlp.html" rel="bookmark" class="title">WPS文字制作公文&OpenCurlyDoubleQuote;三板斧&rdquo;</a>
					<div>
						撰写行政公文是办公室工作人员必备的工作技能之一,公文的撰写过程大体分为文头.正文.落款等三大部分.很多工作人员为了省事,再加上对于&quot;WPS 文字&quot;软件掌握的不够全面,只是运用&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlBW8az.html" rel="bookmark" class="title">Win7如何取消开机显示Windows错误恢复界面</a>
					<div>
						  两种取消开机显示Windows错误恢复界面的方法. 方法一: 1.右击桌面计算机图标,选择&quot;属性&quot;,打开属性界面,然后点击左侧的&quot;高级系统设置&quot;; 2.在打 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8ZwQZb.html" rel="bookmark" class="title">UVA之1330 - City Game</a>
					<div>
						[题目] Bob is a strategy game programming specialist. In his new city building game the gaming environ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/badW9nz.html" rel="bookmark" class="title">返回顶部的功能 div固定在页面位置不变</a>
					<div>
						1.你在网上搜索的时候,可能会搜索到div固定在页面上,不随滚动条滚动而滚动是用CSS写的,写法是position:fixed;bottom:0; 但是这个在iframe满地跑的页面实际开发中,有啥用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvGkDVp.html" rel="bookmark" class="title">AngularJS中的DOM操作用法分析&lowbar;AngularJS</a>
					<div>
						本文实例讲述了AngularJS中的DOM操作用法.分享给大家供大家参考,具体如下: 在angular中使用第三方插件时最好都封装到指令(directives)中去,DOM操作也最好都解构到指令中.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYNaOM.html" rel="bookmark" class="title">可以应用到马克斯电影站生成Rss Feed的代码&lowbar;应用技巧</a>
					<div>
						使用方法:将下面的代码存为rss.asp(记得以UTF-8格式保存)并上传到网站根目录,剩下的工作就是找Rss提交入口去提交你的Feed地址http://你的域名/rss.asp 演示:http:// ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjQEVmz.html" rel="bookmark" class="title">房地产行业正在成为被互联网冲击的又一对象</a>
					<div>
						文|孙宏超 房地产行业正在成为被互联网冲击的又一对象,万达牵手京东.万科联合百度.阿里入股恒大足球.小米也与华润置地达成合作. 在这大潮流的背后是高达万亿以上的产业资本,互联网巨头们试图向线下延伸来提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PkBQp.html" rel="bookmark" class="title">Photoshop通道结合图层模式分离背景</a>
					<div>
						原图 效果图 1.打开素材图片,复制背景图层. 2.进入通道面板,选择一个反差比较大细节保留多的通道进行处理,复制这个通道. 3.图像-调整-色阶,调整色阶数值,来增大通道中的反差. 分类: ps抠图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkw8AEp.html" rel="bookmark" class="title">Ubuntu&sol;Linux 有关权限修改的命令解析&lowbar;Linux</a>
					<div>
						chmod更改文件权限命令 最常用的基础命令chmod chmod 777 目录名(路径名) 777 三位数字分别代表 user.group.others 的权限,可读(r).可写(w).可执行(x) ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6N4OoM.html" rel="bookmark" class="title">require、module、exports dojo中的三个特殊模块标识</a>
					<div>
						查看dojo源码过程中,发现这三个模块名并不以dojo.dijit.dojox开头,在dojo加载器中属于特殊模块名. require 这是一个上下文智能的加载器. 我们通过dojoConfig配置了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkJ57b.html" rel="bookmark" class="title">DropDownList下拉框 onchange事件中，获取字符串Desc 的前三个字符应该怎么写</a>
					<div>
						问题描述 DropDownList下拉框 onchange事件中,获取字符串Desc 的前三个字符应该怎么写 数据绑定: ddlSelect.Attributes.Add(&quot;onchange ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3rVRmz.html" rel="bookmark" class="title">【RAC&comma;DATAGUARD】Creating a physical standby from ASM &lpar;RAC &rpar; primary之四</a>
					<div>
						oracle@rac1:/home/oracle&gt;rman target sys/yang402@rac auxiliary sys/yang402@yangdb Recovery Manage ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Zd5yM.html" rel="bookmark" class="title">cmd rd命令 删除文件夹&lowbar;DOS&sol;BAT</a>
					<div>
						答案是否定的,因为删除文件夹必须使用rd命令,这叫术业有专攻^_^. rd的另外一个写法是rmdir,源自ReMakeDirectory.使用的方法也很简单:rd 文件夹名 即可,例如:rd test ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBdBWM.html" rel="bookmark" class="title">java-spring constructor-arg报错</a>
					<div>
						问题描述 spring constructor-arg报错 最简单的配置一个bean就报错,查了很久不能解决,求助 错误信息: 一月 23, 2015 1:05:12 下午 org.springfra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkAwyEb.html" rel="bookmark" class="title">listview-android studiod 从数据库读取数据失败</a>
					<div>
						问题描述 android studiod 从数据库读取数据失败 从数据库读取数据到listview,但是不知为什么,在没添加数据进数据库的时候,能进activity,但是一旦添加进去以后就开始报错了  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRNRlBM.html" rel="bookmark" class="title">Maven实战&period; 3&period;5使用Archetype生成项目骨架</a>
					<div>
						3.5使用Archetype生成项目骨架 Hello World项目中有一些Maven的约定:在项目的根目录中放置pom.xml,在src/main/java目录中放置项目的主代码,在src/test ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq7eOOz.html" rel="bookmark" class="title">求助！finereport中 怎样在列或行之间做折叠功能</a>
					<div>
						问题描述 因为报表的明细太多,所以想用户点开报表时,先看到的是汇总,例如A-C列折叠起来,然后用户需要看了,再去点开来看,可以是点+号或是其它动作.行折叠一样的意思.而且我是想A-C折叠,F-G折叠, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJqWYJp.html" rel="bookmark" class="title">&period;net mvc3验证Session过期页面跳转问题</a>
					<div>
						问题描述 本人接触MVC3.0不久,做了一点小练习,现在遇到一些小问题.这个是我写的BaseController方法publicclassBaseController:Controller{prote ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmB5naz.html" rel="bookmark" class="title">asp&period;net 读出pdf文件内的文字等信息</a>
					<div>
						问题描述 以asp.net为开发语言,实现从pdf文件中读出信息(不借助第三方软件).大家以前遇到过相似的开发没有,想听听大家的建议. 解决方案 解决方案二:真是开眼界啊,原来ASP.net还能读取P ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b22KBVb.html" rel="bookmark" class="title">看工程造价行业是如何玩转大数据的！</a>
					<div>
						造价行业一直被比作&quot;老中医&quot;行业,认为造价师有经验就有价值.为什么,无非是其自身通过项目的实践,积累了大量的经验数据. 数据和经验跟随员工流动,企业就无法从公司层面进行数据和经验累 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9jjr3p.html" rel="bookmark" class="title">归纳下js面向对象的几种常见写法总结&lowbar;javascript技巧</a>
					<div>
						//定义Circle类,拥有成员变量r,常量PI和计算面积的成员函数area()  1.工厂方式 var Circle = function() { var obj = new Object(); o ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MR17Zqb.html" rel="bookmark" class="title">asp xmlhttp 采集网页内容代码</a>
					<div>
						&lt;html&gt; &lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; char ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
